"""
/*
 *  _____ _______         _                      _
 * |_   _|__   __|       | |                    | |
 *   | |    | |_ __   ___| |___      _____  _ __| | __  ___ ____
 *   | |    | | '_ \ / _ \ __\ \ /\ / / _ \| '__| |/ / / __|_  /
 *  _| |_   | | | | |  __/ |_ \ V  V / (_) | |  |   < | (__ / /
 * |_____|  |_|_| |_|\___|\__| \_/\_/ \___/|_|  |_|\_(_)___/___|
 *                   ___
 *                  |  _|___ ___ ___
 *                  |  _|  _| -_| -_|  LICENCE
 *                  |_| |_| |___|___|
 *
 *    REKVALIFIKAČNÍ KURZY  <>  PROGRAMOVÁNÍ  <>  IT KARIÉRA
 *
 * Tento zdrojový kód pochází z IT kurzů na WWW.ITNETWORK.CZ
 *
 * Můžete ho upravovat a používat jak chcete, musíte však zmínit
 * odkaz na https://www.itnetwork.cz
 */
"""

from fastapi import FastAPI

app = FastAPI()


movie_db = {
    1: {"movie_name": "Star Wars", "director": "George Lucas"},
    2: {"movie_name": "Frozen", "director": "Adam Green"},
    3: {"movie_name": "Shrek", "director": "Vicky Jenson"},
}


@app.get("/")
async def index():
    return {"message": "Hello World"}


@app.get("/movies/{movie_id}")
async def read_movie(movie_id: int):
    return {"movie_id": movie_id}


@app.get("/movies/")
async def find_movie(movie_name: str | None = None, director: str | None = None):
    result = {"message": "Movie not found"}

    if movie_name is None and director is None:
        return result

    for movie_id, movie in movie_db.items():
        if (movie_name is None or movie["movie_name"].lower() == movie_name.lower()) and \
           (director is None or movie["director"].lower() == director.lower()):
            result = {"movie_id": movie_id, "movie_details": movie}
            break

    return result
